unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, NMUDP, StdCtrls, Sockets, IdTCPConnection, IdTCPClient,
  IdBaseComponent, IdComponent, IdTCPServer;

type
  TForm1 = class(TForm)
    NMUDP1: TNMUDP;
    Button1: TButton;
    OpenDialog1: TOpenDialog;
    SaveDialog1: TSaveDialog;
    Edit1: TEdit;
    Label1: TLabel;
    procedure NMUDP1DataReceived(Sender: TComponent; NumberBytes: Integer;
      FromIP: String; Port: Integer);
    procedure Button1Click(Sender: TObject);
    procedure Edit1Change(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;
const timeout=(1.0/(24.0*60.0*60.0));
var
  Form1: TForm1;
  fp:File;
  fpopened:boolean=false;
  filetot,filecur:integer;

  ack:integer=0;
implementation

{$R *.dfm}

procedure TForm1.NMUDP1DataReceived(Sender: TComponent;
  NumberBytes: Integer; FromIP: String; Port: Integer);
var
  C: String;
  MyStream: TMemoryStream;
  readed,i:integer;
  buf:array[1..1034] of char;
  fn,sizes:string;
begin
  MyStream := TMemoryStream.Create;
  try
    readed:=NumberBytes;
    NMUDP1.ReadBuffer(buf,readed);
    if readed>=2 then
    begin
       if (buf[1]='A') and (buf[2]='K')then
       begin
         ack:=1;
       end;
       if (buf[1]='N') and (buf[2]='K')then
       begin
         ack:=2;
       end;
       if (buf[1]='O') and (buf[2]='K')then
       begin
         caption:='ǳƱ!';
         c:='AK';
         MYStream.Clear;
         MyStream.Write(C[1], Length(C));
         NMUDP1.SendStream(MyStream);
       end
       else
       if (buf[1]='O') and (buf[2]='P')then
       begin
          sizes:='';
          for i:=3 to 3+9 do
            sizes:=sizes+buf[i];
          filetot:=strtointdef(trim(sizes),0);
          filecur:=0;
          fn:='';
          for i:=3+10 to readed do
            fn:=fn+buf[i];
          SaveDialog1.Title:='пܱɮצsɦm,YQɮ׽Ы';
          SaveDialog1.FileName:=fn;
          if fpopened then
          try
            closefile(fp);
          except
          end;
          fpopened:=false;
          if savedialog1.Execute then
          begin
            assignfile(fp,savedialog1.filename);
            rewrite(fp,1);
            fpopened:=true;
            caption:='ɮ:'+fn;
    c:='AK';
    MYStream.Clear;
    MyStream.Write(C[1], Length(C));
    NMUDP1.SendStream(MyStream);
          end
          else
          begin
    c:='NK';
    MYStream.Clear;
    MyStream.Write(C[1], Length(C));
    NMUDP1.SendStream(MyStream);
          end;
       end;
       if fpopened then
       if (buf[1]='D') and (buf[2]='A')then
       begin
          BlockWrite(fp,buf[3],readed-2);
          filecur:=filecur+readed-2;
    c:='AK';
    MYStream.Clear;
    MyStream.Write(C[1], Length(C));
    NMUDP1.SendStream(MyStream);
//          caption:=':'+inttostr(readed-2)+'bytes';
       caption:=':'+inttostr(filecur)+'/'+inttostr(filetot)+'bytes '+inttostr((filecur*100) div filetot)+'%';
       end;
       if fpopened then
       if (buf[1]='C') and (buf[2]='L')then
       begin
          closefile(fp);
          fpopened:=False;
          caption:='!';
    c:='AK';
    MYStream.Clear;
    MyStream.Write(C[1], Length(C));
    NMUDP1.SendStream(MyStream);
       end;
    end;
  finally
    MyStream.Free;
  end;
end;


procedure TForm1.Button1Click(Sender: TObject);
var
  fp:file;
  C,fn: String;
  myStream:TMemoryStream;
  buf:array[1..1024+2] of char;
  readed:integer;
  timer:double;
  tot,cur:integer;
  t1,t2:double;
  ok:boolean;
begin
  ok:=false;
  opendialog1.Title:='пܶǰeɮ';
  if not opendialog1.execute then exit;
  NMUDP1.RemoteHost := edit1.text;
  NMUDP1.ReportLevel := Status_Basic;
  NMUDP1.RemotePort := 6668;
  fn:=extractfilename(opendialog1.filename);
  assignfile(fp,opendialog1.filename);
  reset(fp,1);
  tot:=filesize(fp);
  myStream:=TMemoryStream.create;
  try
    caption:='M!';
    c:='OK';
    MYStream.Clear;
    ack:=0;
    MyStream.Write(C[1], Length(C));
    NMUDP1.SendStream(MyStream);
    timer:=now+timeout*3;
    while (ack=0) AND (now<=timer) do application.ProcessMessages;
    if ack<>1 then exit;


    caption:='ǰeɮ:'+fn;
    c:='OP'+format('%10d',[tot])+fn;
    MYStream.Clear;
    ack:=0;
    MyStream.Write(C[1], Length(C));
    NMUDP1.SendStream(MyStream);
    timer:=now+timeout*30;
    while (ack=0) AND (now<=timer) do application.ProcessMessages;
    if ack<>1 then exit;
    buf[1]:='D';
    buf[2]:='A';
    cur:=0;
    while not eof(fp) do
    begin
       MYStream.Clear;
       MyStream.Write(buf,2);
       BlockRead(fp,buf[3],1024,readed);
       cur:=cur+readed;
       ack:=0;
       MyStream.Write(buf[3],readed);
       t1:=now;
       NMUDP1.SendStream(MyStream);
       timer:=now+timeout*10;
       while (ack=0) AND (now<=timer) do application.ProcessMessages;
       t2:=(now-t1);
       t2:=t2*24*60*60;
       if t2=0 then t2:=0.00001;
       t2:=t2*1024;
       if ack<>1 then  exit;
       try
       caption:='ǰe:'+inttostr(cur)+'/'+inttostr(tot)+'bytes '+inttostr((cur*100) div tot)+'% ǰetv:'+format('%.1f',[readed/t2])+'K/Sec';
       except
       end;
    end;
    c:='CL'+FN;
    MYStream.Clear;
    ack:=0;
    MyStream.Write(C[1], Length(C));
    NMUDP1.SendStream(MyStream);
    timer:=now+timeout*10;
    while (ack=0) AND (now<=timer) do application.ProcessMessages;
    if ack<>1 then exit;
    ok:=true;
  finally
    closefile(fp);
    myStream.Free;
    if ok then
    caption:='ǰe!'
    else
    caption:='ǰe!';
  end;
end;

procedure TForm1.Edit1Change(Sender: TObject);
begin
  NMUDP1.RemoteHost := edit1.text;
end;

end.
